## 16c44156c856c6fb368e60ebc233ab47025305b2

=== Makefile ===
SHELL=bash
CFLAGS=-std=gnu99 -static -s -Wall -Werror -O3

TEST_PACKAGE_DEPS := build-essential python python-pip procps python-dev python-setuptools

DOCKER_RUN_TEST := docker run -v $(PWD):/mnt:ro

.PHONY: build
build: VERSION.h
	$(CC) $(CFLAGS) -o dumb-init dumb-init.c

VERSION.h: VERSION
	echo '// THIS FILE IS AUTOMATICALLY GENERATED' > VERSION.h
	echo '// Run `make VERSION.h` to update it after modifying VERSION.' >> VERSION.h
	xxd -i VERSION >> VERSION.h

.PHONY: clean
clean: clean-tox
	rm -rf dumb-init dist/ *.deb

.PHONY: clean-tox
clean-tox:
	rm -rf .tox

.PHONY: release
release: python-dists builddeb-docker
	$(eval VERSION := $(shell cat VERSION))
	# extract the built binary from the Debian package
	dpkg-deb --fsys-tarfile dist/dumb-init_$(VERSION)_amd64.deb | \
		tar -C dist --strip=3 -xvf - ./usr/bin/dumb-init
	mv dist/dumb-init dist/dumb-init_$(VERSION)_amd64
	cd dist && \
		sha256sum --binary dumb-init_$(VERSION)_amd64.deb dumb-init_$(VERSION)_amd64 \
		> sha256sums

.PHONY: python-dists
python-dists: VERSION.h
	python setup.py sdist
	docker run \
		--user $$(id -u):$$(id -g) \
		-v $(PWD)/dist:/dist:rw \
		quay.io/pypa/manylinux1_x86_64:latest \
		bash -exc ' \
			/opt/python/cp35-cp35m/bin/pip wheel --wheel-dir /tmp /dist/*.tar.gz && \
			auditwheel repair --wheel-dir /dist /tmp/*.whl --wheel-dir /dist \
		'

.PHONY: builddeb
builddeb:
	debuild --set-envvar=CC=musl-gcc -us -uc -b
	mkdir -p dist
	mv ../dumb-init_*.deb dist/

.PHONY: builddeb-docker
builddeb-docker: docker-image
	mkdir -p dist
	docker run -v $(PWD):/mnt dumb-init-build

.PHONY: docker-image
docker-image:
	docker build -t dumb-init-build .

.PHONY: test
test:
	tox
	tox -e pre-commit

.PHONY: install-hooks
install-hooks:
	tox -e pre-commit -- install -f --install-hooks

ITEST_TARGETS = itest_lucid itest_precise itest_trusty itest_xenial itest_wheezy itest_jessie itest_stretch

.PHONY: itest $(ITEST_TARGETS)
itest: $(ITEST_TARGETS)

itest_lucid: _itest-ubuntu-lucid
itest_precise: _itest-ubuntu-precise
itest_trusty: _itest-ubuntu-trusty
itest_xenial: _itest-ubuntu-xenial
itest_wheezy: _itest-debian-wheezy
itest_jessie: _itest-debian-jessie
itest_stretch: _itest-debian-stretch

itest_tox:
	$(DOCKER_RUN_TEST) ubuntu:xenial /mnt/ci/docker-tox-test

_itest-%: _itest_deb-% _itest_python-%
	@true

_itest_python-%:
	$(DOCKER_RUN_TEST) $(shell sed 's/-/:/' <<< "$*") /mnt/ci/docker-python-test

_itest_deb-%: builddeb-docker
	$(DOCKER_RUN_TEST) $(shell sed 's/-/:/' <<< "$*") /mnt/ci/docker-deb-test

=== debian/changelog ===
dumb-init (1.2.0) unstable; urgency=medium

  * Hand the controlling TTY to the child process, if we have one (#122).

    This fixes warnings that are printed when running a typical command like:
        docker run -ti <image> dumb-init bash
    ...as well as allowing you to use job control.

    Thanks to @ehlers for the patch, and @alhafoudh (and several others) for
    reporting the issue and providing details!

 -- Chris Kuehl <ckuehl@yelp.com>  Mon, 10 Oct 2016 14:09:57 -0700

dumb-init (1.1.3) unstable; urgency=low

  * Add support for FreeBSD kernel. Thanks @onlyjob for bringing this to our
    attention.

 -- Chris Kuehl <ckuehl@yelp.com>  Tue, 02 Aug 2016 10:57:11 -0700

dumb-init (1.1.2) unstable; urgency=low

  * Fix race when the child exits very quickly that leads to dumb-init not
    reaping the child. This should be pretty rare and most likely to happen
    when dumb-init's child fails to exec (such as when you try to run a file
    that doesn't exist).

 -- Chris Kuehl <ckuehl@yelp.com>  Mon, 25 Jul 2016 22:46:40 -0700

dumb-init (1.1.1) unstable; urgency=medium

  * Fix segfault when passing unknown arguments (thanks @asottile for
    noticing!) (#88).

 -- Chris Kuehl <ckuehl@yelp.com>  Fri, 17 Jun 2016 12:11:22 -0700

dumb-init (1.1.0) unstable; urgency=medium

  * Add ability to rewrite incoming signals before proxying via the --rewrite
    flag. Thanks @mcclurmc for the PR (#83)!
  * Add ability to not rewrite incoming "suspend" job control signals in
    setsid mode (#85).
  * Add ability to ignore (not proxy) incoming signals (#86).

 -- Chris Kuehl <ckuehl@yelp.com>  Tue, 14 Jun 2016 11:45:50 -0700

dumb-init (1.0.3) unstable; urgency=medium

  * Fix incorrect error message when calling with bad arguments (e.g. a
    command which did not exist) and passing flags (#82).
  * Tag Python packages of dumb-init properly (#75).

 -- Chris Kuehl <ckuehl@yelp.com>  Wed, 01 Jun 2016 20:25:24 -0400

dumb-init (1.0.2) unstable; urgency=low

  * Rewrite signal handling to process signals synchronously (#72).
    This shouldn't change behavior, but does eliminate some undefined behavior
    and potential edge cases (especially race conditions).
    Thanks @msavage20 for the bug report (again)!

 -- Chris Kuehl <ckuehl@yelp.com>  Mon, 02 May 2016 10:59:14 -0700

dumb-init (1.0.1) unstable; urgency=low

  * Fix exit status for processes which exit due to signal (#59).
    Thanks @msavage20 for the bug report!

 -- Chris Kuehl <ckuehl@yelp.com>  Fri, 11 Mar 2016 14:05:58 -0800

dumb-init (1.0.0) unstable; urgency=low

  * Compile dumb-init with musl and strip the binary of unnecessary symbols
    (thanks Konrad Scherer)
  * Fix some typos (thanks Anthony Sottile)
  * Add a manpage to the Debian package

 -- Chris Kuehl <ckuehl@yelp.com>  Thu, 07 Jan 2016 15:00:19 -0800

dumb-init (0.5.0) unstable; urgency=low

  * Add command-line option parsing (supplements existing environment
    variables).
  * Prefix debug output with '[dumb-init]'

 -- Chris Kuehl <ckuehl@yelp.com>  Fri, 02 Oct 2015 18:12:51 -0700

dumb-init (0.4.0) unstable; urgency=medium

  * Properly respond to job control signals (SIGTSTP, SIGTTIN, SIGTTOU).

    This makes it possible to suspend dumb-init (and its child process) by
    hitting ^Z in an interactive shell session.

 -- Chris Kuehl <ckuehl@ocf.berkeley.edu>  Tue, 29 Sep 2015 13:45:06 -0700

dumb-init (0.3.1) unstable; urgency=medium

  * Exit nonzero if exec() fails (such as trying to run a nonexistent process)

 -- Chris Kuehl <ckuehl@yelp.com>  Tue, 29 Sep 2015 11:18:12 -0700

dumb-init (0.3.0) unstable; urgency=low

  * Send TERM to all processes in the session when the primary child dies when
    running in setsid mode.

 -- Chris Kuehl <ckuehl@yelp.com>  Fri, 18 Sep 2015 11:08:05 -0700

dumb-init (0.2.0) unstable; urgency=low

  * Use setsid for process-group behavior. This fixes tty interaction.
  * Properly reap zombie processes.

 -- Kent Wills <rkwills@yelp.com>  Thu, 10 Sep 2015 13:33:25 -0700

dumb-init (0.1.0) unstable; urgency=low

  * Add process group support

 -- Chris Kuehl <ckuehl@yelp.com>  Thu, 03 Sep 2015 17:55:44 -0700

dumb-init (0.0.2) unstable; urgency=low

  * Exit with the same exit status as the process we call.
  * Print a more useful help message when called with no arguments.

 -- Chris Kuehl <ckuehl@yelp.com>  Thu, 06 Aug 2015 13:51:38 -0700

dumb-init (0.0.1) unstable; urgency=low

  * Initial release.

 -- Chris Kuehl <ckuehl@yelp.com>  Thu, 06 Aug 2015 13:51:38 -0700

=== debian/control ===
Source: dumb-init
Section: utils
Priority: extra
Maintainer: Chris Kuehl <ckuehl@yelp.com>
Uploaders: Kent Wills <rkwills@yelp.com>
Build-Depends:
 debhelper (>= 9),
 help2man,
 musl-tools,
## Tests:
 procps,
 python,
 python-mock,
 python-pytest,
Standards-Version: 3.9.7
Homepage: https://github.com/Yelp/dumb-init
Vcs-Browser: https://github.com/Yelp/dumb-init
Vcs-Git: https://github.com/Yelp/dumb-init.git

Package: dumb-init
Architecture: any
Depends: ${misc:Depends}
Description: wrapper script which proxies signals to a child
 dumb-init is a simple process supervisor and init system designed to run
 as PID 1 inside minimal container environments (such as Docker).
 .
 Lightweight containers have popularized the idea of running a single
 process or service without normal init systems like systemd or sysvinit.
 However, omitting an init system often leads to incorrect handling of
 processes and signals, and can result in problems such as containers
 which can't be gracefully stopped, or leaking containers which should
 have been destroyed.
 .
 dumb-init acts as PID 1 and immediately spawns your command as a child
 process, taking care to properly handle and forward signals as they are
 received.
